// OTPz201Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "OTPz201.h"
#include "OTPz201Dlg.h"
#include "otp_interface.h"

#pragma comment(lib,"ET_OTPVerify.lib")

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

char g_authkey[] = "ll598C28E54BF3C58EC35E830655A139861407519FCBC92140";
uint64_t g_currsucc = 0;
int g_currdft = 0;
uint64_t g_lastsucc = 0;
int g_lastdrift = 0;

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COTPz201Dlg dialog

COTPz201Dlg::COTPz201Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(COTPz201Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(COTPz201Dlg)
	m_strOTPVerify = _T("");
	m_strSyn1 = _T("");
	m_strSyn2 = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void COTPz201Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COTPz201Dlg)
	DDX_Text(pDX, IDC_EDIT_Verify, m_strOTPVerify);
	DDV_MaxChars(pDX, m_strOTPVerify, 6);
	DDX_Text(pDX, IDC_EDIT_Syn1, m_strSyn1);
	DDV_MaxChars(pDX, m_strSyn1, 6);
	DDX_Text(pDX, IDC_EDIT_Syn2, m_strSyn2);
	DDV_MaxChars(pDX, m_strSyn2, 6);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(COTPz201Dlg, CDialog)
	//{{AFX_MSG_MAP(COTPz201Dlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_Verify, OnBUTTONVerify)
	ON_BN_CLICKED(IDC_BUTTON_Syn, OnBUTTONSyn)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COTPz201Dlg message handlers

BOOL COTPz201Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void COTPz201Dlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void COTPz201Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR COTPz201Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void COTPz201Dlg::OnBUTTONVerify() 
{
	// TODO: Add your control notification handler code here
    char otp_verify[7]={0};
	
	time_t ltime; 
	time(&ltime ); 
	
	int i=0;
	int ret = 0;
	
	UpdateData(TRUE);

	if(m_strOTPVerify.GetLength() != 6)
	{
			AfxMessageBox("볤Ϊ6");
			return;
	}

	for(i=0; i<m_strOTPVerify.GetLength(); ++i)
	{
		if(m_strOTPVerify.GetAt(i)<0x30 || m_strOTPVerify.GetAt(i)>0x39)
		{
			AfxMessageBox("볤Ϊ6");
			return;
		}
	}
	

	ret = ET_CheckPwdz201(g_authkey, ltime, 0, 60, g_lastdrift, 20, g_lastsucc, 
        m_strOTPVerify.GetBuffer(0), 6, &g_currsucc, &g_currdft);
	if(ret == 0)
	{
		g_lastdrift = g_currdft;
		g_lastsucc = g_currsucc;
		AfxMessageBox("֤ɹ");
	}
	else
	{
		AfxMessageBox("֤ʧܣ");
	}


	
}

void COTPz201Dlg::OnBUTTONSyn() 
{
	// TODO: Add your control notification handler code here
	
 	char otp_syn1[7]={0};
	char otp_syn2[7]={0};

	uint64_t currsucc = 0;
	int currdft = 0;
	uint64_t lastsucc = 0;
	int lastdrift = 0;
	
	time_t ltime; 
	time(&ltime ); 
	
	int i=0;
	int ret = 0;
	
	UpdateData(TRUE);

	if((m_strSyn1.GetLength() != 6) || (m_strSyn2.GetLength() != 6))
	{
			AfxMessageBox("볤Ϊ6");
			return;
	}

	for(i=0; i<m_strSyn1.GetLength(); ++i)
	{
		if(m_strSyn1.GetAt(i)<0x30 || m_strSyn1.GetAt(i)>0x39 ||
			m_strSyn2.GetAt(i)<0x30 || m_strSyn2.GetAt(i)>0x39)
		{
			AfxMessageBox("볤Ϊ6");
			return;
		}
	}
	

	ret = ET_Syncz201(g_authkey, ltime, 0, 60, g_lastdrift, 40, g_lastsucc, 
            m_strSyn1.GetBuffer(0), 6, m_strSyn2.GetBuffer(0), 6, &g_currsucc, &g_currdft);
	if(ret == 0)
	{
		g_lastdrift = g_currdft;
		g_lastsucc = g_currsucc;
		AfxMessageBox("ͬɹ");
	}
	else
	{
		AfxMessageBox("ͬʧܣ");
	}
}
